% Author: Michele Bozzano

jaroWinklerDistance(Str1,Str2,Distance):-
       matchRange(Str1,Str2,Range),
       upcase_atom(Str1,Str1Upper),
       upcase_atom(Str2,Str2Upper),
       atom_codes(Str1Upper,A1),
       atom_codes(Str2Upper,A2),
       length(A1,Lun1),
       length(A2,Lun2),
       commons(A1,A2,Range,Kmod,Num_com), /*Kmod lista con i char comuni e non (comuni marcati da 0 a Num_com-1)*/
       (Num_com =:= 0, Distance is 0,!
       ;
       pulisciLista(Kmod,Kpul),
       calcolaEsatte(0,Kpul,0,Esatte),
       T is (Num_com - Esatte)/2,
       Dist is (Num_com/Lun1 + Num_com/Lun2 + (Num_com - T)/Num_com)/3,
       primeInComune(A1,A2,Lamda),
       (Lamda > 4, Gamma is 4, ! ; Lamda =< 4, Gamma is Lamda),
       Distance is Dist+(Gamma/10*(1-Dist))
       ).

/* matchRange = max(cs1.length(), cs2.length()) / 2 - 1 */
matchRange(Str1,Str2,Range):-
       string_length(Str1,L1),
       string_length(Str2,L2),
       (L1 >= L2,!, Range1 is L1 //2 -1 ; Range1 is L2 //2 -1),
       (Range1 > 0,Range is Range1,! ; Range is 0).

commons(A1,A2,Range,Kmod,Num_com):-
       length(A2,Lungh),
       matches(A1,A2,Range,Lungh,1,0,Kmod,Num_com).

matches([],Kmod,_,_,_,Acc,Kmod,Acc).
matches([E|L],K,Range,Lungh,I,Acc,Kmod1,Num_com):-
       (I > Range, Lowlim is I - Range, ! ; Lowlim is 1),
       ((I + Range) =< Lungh, Hilim is I + Range, ! ; Hilim is Lungh),
       /*estraiLaListaDaControllare LDC */
       LenInit is Lowlim - 1, LenLDC is Hilim - LenInit, LenFin is Lungh - Hilim,
       length(Iniz,LenInit),length(LDC,LenLDC),length(Fin,LenFin),append(Iniz,LDC,Prime2),append(Prime2,Fin,K),
       (match(E,LDC,Acc,Modif),Acc1 is Acc + 1, append(Iniz,Modif,Parte1),append(Parte1,Fin,Kmod),!
       ;
       Acc1 is Acc, append(Iniz,LDC,Parte1),append(Parte1,Fin,Kmod)),
       I1 is I+1,
       matches(L,Kmod,Range,Lungh,I1,Acc1,Kmod1,Num_com).


/*sostituisci al valore trovato nella lista un l'accomulatore */
match(_,[],_,_):-fail.
match(E,[M|L],Acc,[Acc200|L]):-
       M =:= E,
       Acc200 is Acc + 200,!.
match(E,[NM|L],Acc,Modif):-
       match(E,L,Acc,Mod),
       append([NM],Mod,Modif).

/*restano i caratteri comuni*/
pulisciLista([],[]):-!.
pulisciLista([E|K],[Cont|P]):-
       E >= 200,!,
       Cont is E - 200,
       pulisciLista(K,P).

pulisciLista([E|K],P):-
       E < 200,
       pulisciLista(K,P).
/*numero di lettere che non necesittano trasposizione*/
calcolaEsatte(_,[],Esatte,Esatte):-!.
calcolaEsatte(N,[N|K],Acc,Esatte):-
       !,Acc1 is Acc+1,
       N1 is N+1,
       calcolaEsatte(N1,K,Acc1,Esatte).
calcolaEsatte(N,[X|K],Acc,Esatte):-
       N \= X,
       N1 is N+1,
       calcolaEsatte(N1,K,Acc,Esatte).

/*primi char in comune*/
primeInComune([],_,0):-!.
primeInComune(_,[],0):-!.
primeInComune([E|L],[E|K],N):-
       !,primeInComune(L,K,N1),
       N is N1 + 1.
primeInComune([E|_],[X|_],0):-
       E \= X.