% Author: MB
% Date: 24/11/2009

%lookAheadList(L,ListaConcetti).
%ListaDiConcetti  la lista delle parole di L, se alcune parole consecutive hanno un significato proprio vengono composte
lookAheadList([],[]):-!.

lookAheadList(L,[Concetto|ListaConcetti]):-
    lookAhead(L,Concetto,Resto),
    lookAheadList(Resto,ListaConcetti).

%lookAhead(+L,?Concetto,?Rest).
%Concetto  unificato con il concatenamento di 1/2/3/4 stringhe in testa a L che abbiano un significato una volta composte
lookAhead([W1,W2,W3,W4|R],Concetto,R):-
     concat(W1,' ',A1),
     concat(W2,' ',A2),
     concat(W3,' ',A3),
     concat(A1,A2,X),
     concat(X,A3,Y),
     concat(Y,W4,Concetto),
     my_s(_,_,Concetto,_,_,_),!.
     
lookAhead([W1,W2,W3,W4|R],Concetto,R):-
     minuscola(W1,W1m),
     minuscola(W2,W2m),
     minuscola(W3,W3m),
     minuscola(W4,W4m),
     concat(W1m,' ',A1),
     concat(W2m,' ',A2),
     concat(W3m,' ',A3),
     concat(A1,A2,X),
     concat(X,A3,Y),
     concat(Y,W4m,Concetto),
     my_s(_,_,Concetto,_,_,_),!.
     
lookAhead([W1,W2,W3|R],Concetto,R):-
     concat(W1,' ',A1),
     concat(W2,' ',A2),
     concat(A1,A2,X),
     concat(X,W3,Concetto),
     my_s(_,_,Concetto,_,_,_),!.
     
lookAhead([W1,W2,W3|R],Concetto,R):-
     minuscola(W1,W1m),
     minuscola(W2,W2m),
     minuscola(W3,W3m),
     concat(W1m,' ',A1),
     concat(W2m,' ',A2),
     concat(A1,A2,X),
     concat(X,W3m,Concetto),
     my_s(_,_,Concetto,_,_,_),!.
     
lookAhead([W1,W2|R],Concetto,R):-
     concat(W1,' ',A1),
     concat(A1,W2,Concetto),
     my_s(_,_,Concetto,_,_,_),!.

lookAhead([W1,W2|R],Concetto,R):-
     minuscola(W1,W1m),
     minuscola(W2,W2m),
     concat(W1m,' ',A1),
     concat(A1,W2m,Concetto),
     my_s(_,_,Concetto,_,_,_),!.
     
lookAhead([W1|R],W1,R).

%minuscola(+W,?Wm).
%rende una parola minuscola
minuscola(W,Wm):-
     atom_codes(W,AC),
     iteraMin(AC,ACm),
     atom_codes(Wm,ACm).

%iteraMin(+W,?Wm).
%rende ogni carattere minuscolo
iteraMin([],[]):-!.
iteraMin([C|R],[Cm|Rm]):-
     C>=65,C=<90,!,
     Cm is C + 32,
     iteraMin(R,Rm).
iteraMin([C|R],[C|Rm]):-
     iteraMin(R,Rm).