% Author: Michele Bozzano
% Date: 27/11/2009

% la lista delle parole comuni trovate nel testo
:- dynamic commonWords/1.
%  stato trovato un punto durante l'estrazione di parole
:- dynamic point/1.
% tutto il testo tra parentesi aperta e chiusa
:- dynamic betweenBrackets/1.
% tutte le coniugazioni asserite da me
:- dynamic ass_s/6.
%tutti i ruoli scritti sul file
:- dynamic role/4.

%dimensione della finestra
windowsLength(5).

:- ensure_loaded('wn_s.pl').
:- ensure_loaded('wn_hyp.pl').
:- ensure_loaded('wn_mm.pl').
:- ensure_loaded('wn_sim.pl').
:- ensure_loaded('wn_g.pl').
:- ensure_loaded('wn_ins.pl').
:- ensure_loaded('freq8000words.pl').
:- ensure_loaded('artAndPrep.pl').
:- ensure_loaded('preProcess.pl').
:- ensure_loaded('wn_tools.pl').
:- ensure_loaded('disambigua.pl').
:- ensure_loaded('lookAhead.pl').
:- ensure_loaded('wordRecognition.pl').
:- ensure_loaded('tokenizeToPoint.pl').
:- ensure_loaded('findRoleByGloss.pl').
:- ensure_loaded('jaroWinkler.pl').
:- ensure_loaded('findRelationsByPOS.pl').

%start(+Testo).
%richiama la funzione di preprocess e il main
start:-
    Testo0 = "Two young Irishmen in a Canadian regiment went into the war for the first time, and their captain promised them five pounds each for every German they killed.Pat lay down to rest, and Mick was on watch. After a while Mick woke Pat up and shouted:They're coming! They're coming!Who's coming? shouted Pat.Replied Mick.The Germans,How many are there?About fifty thousand.My God!shouted Pat.Then he jumped, took his rifle and said:How lucky we are! We are going to be very rich!",
    Testo1 = "In science fiction the Three Laws of Robotics are a set of three rules written by Isaac Asimov which almost all positronic robots appearing in his fiction must obey.",
    Testo2 = "Introduced in his 1942 short story Runaround, although foreshadowed in a few earlier stories, the Laws state the following: 1. A robot may not injure a human being or, through inaction, allow a human being to come to harm. 2. A robot must obey any orders given to it by human beings, except where such orders would conflict with the First Law. 3. A robot must protect its own existence as long as such protection does not conflict with the First or Second Law.",
    Testo3 = "A frog said to a cow: is white the color of the milk? the cow replayed: of course!",
    Testo4 = "Mrs Gibson had some guests in her house. She wanted to show them her house. When they were in her living room one of the guests noticed a lock of hair in a glass container.What is it? the guest wanted to know.It is my husband's hair.But your husband is still alive! the guest exclaimed.Yes, but his hair is gone.",
    Testo5 = "When his daughter returned from the girls' college, the farmer looked at her critically, and then asked: Are not you a lot fatter than you were? Yes, dad; the girl admitted. I weigh one hundred and forty pounds stripped for gym. The father stared for a moment in horrified amazement, then shouted: Who on Earth is Jim?",
    Testo6 = "The king declare war to France.",
    Testo7 = "Colorless green ideas sleep furiously.",
    Testo8 = "The cat devoured avidly its tasty pet food.",
    Testo9 = "Time flies like an arrow",
    Testo10 = "Yesterday I've seen a professional tennis player at the tennis pitch!",
    TestoLet1 = "It was a bright cold day in April, and the clocks were striking thirteen. Winston Smith, his chin nuzzled into his breast in an effort to escape the vile wind, slipped quickly through the glass doors of Victory Mansions, though not quickly enough to prevent a swirl of gritty dust from entering along with him.",
    TestoLet2 = "The hallway smelt of boiled cabbage and old rag mats. At one end of it a coloured poster, too large for indoor display, had been tacked to the wall. It depicted simply an enormous face, more than a metre wide: the face of a man of about forty-five, with a heavy black moustache and ruggedly handsome features.",
    TestoLet3 = "A short time ago--(this _not long ago_ is with us men--centuries)--my rays followed a young artist; it was in the realm of the Pope, in the city of the world, in Rome. Many changes have been made, but the imperial palace, was, as it is to-day, a ruin; between the overthrown marble columns and over the ruined bath-rooms, whose walls were still decorated with gold, grew fig and laurel trees.",
    TestoLet4 = "FOR the most wild, yet most homely narrative which I am about to pen, I neither expect nor solicit belief. Mad indeed would I be to expect it, in a case where my very senses reject their own evidence. Yet, mad am I not - and very surely do I not dream. But to-morrow I die, and to-day I would unburthen my soul.",
    TestoNews1 = "Opposition to nuclear power in Italy is based on prejudice, unjustified fear and suspicion, according to the head of the Italian electricity utility ENEL. Nuclear power is cleaner, safer and more socially responsible. It is part of the solution to move towards greater independence and is friendly to the environment; ENEL's chief executive officer Fulvio Conti said at a roundtable discussion here.",
    TestoNews2 = "The federal government was shuttered Monday while the Mid-Atlantic region dug out from as much as three feet of snow that left tens of thousands without power and blocked trains, planes and cars, with another storm looming. Federal agencies that employ 230,000 in Washington were closed, as were many local governments, businesses and school districts across the region.",
    TestoNews3 = "A body was found inside a wheel well of a Delta Air Lines plane after it landed in Tokyo from New York, and Japanese authorities Monday were trying to identify the man. The body of the apparent stowaway was clad only in a long-sleeved, plaid shirt and jeans, police at Narita International Airport said.",
    TestoNews4 = "It's been more than a decade since Amy, as she's known in court papers, was first sexually abused by her uncle. The abuse ended long ago and he's in prison, but the pictures he made when she was 8 or 9 are among the most widely circulated child pornography images online. Now the 20-year-old woman is taking aim at anyone who would view those images and asking for restitution in hundreds of criminal cases around the country.",
    TestoSci1 = "The Big Bang theory is an effort to explain what happened at the very beginning of our universe. Discoveries in astronomy and physics have shown beyond a reasonable doubt that our universe did in fact have a beginning. Prior to that moment there was nothing; during and after that moment there was something: our universe. The big bang theory is an effort to explain what happened during and after that moment.",
    TestoSci2 = "Crohn's disease is a chronic, relapsing inflammatory condition affecting any part of the human gastrointestinal tract. It is characterised by transmural inflammation with deep ulceration, thickening of the bowel wall and fistula formation. The hallmark is the non-caseating granuloma. Clinical presentation depends upon the site of the inflammation.",
    TestoSci3 = "Astrophysics is the branch of astronomy that deals with the physics of the universe, including the physical properties (luminosity, density, temperature and chemical composition) of astronomical objects such as stars, galaxies, and the interstellar medium, as well as their interactions.",
    TestoSci4 = "The formation of galaxies is still one of the most active research areas in astrophysics; and, to some extent, this is also true for galaxy evolution. Some ideas, however, are now widely accepted. After the Big Bang, the universe had a period when it was remarkably homogeneous, as can be observed in the Cosmic Microwave Background, the fluctuations of which are less than one part in one hundred thousand.",
    preprocess(Testo8,ParoleComuni),
    retractall(point(_)),
    retractall(betweenBrackets(_)),
    retractall(commonWords(_)),
    retractall(role(_,_,_,_)),
    retractall(ass_s(_,_,_,_,_,_)),
    assert(commonWords(ParoleComuni)),
    tell('ruoli.pl'),
    main(Testo8).

%main(+Testo).
%fa il lavoro sulla parte di Testo fino al punto, poi ricorre.
main([]):-!,told.
main(Testo):-
    tokenizeToPoint(Testo, ListaParoleFinoAlPunto,Rest),        %tutte le parole fino al punto
    lookAheadList(ListaParoleFinoAlPunto,ListaConcetti),        %unifica i concetti
    rimuoviNonSignificativi(ListaConcetti,ListaConcettiPulita), %tolgo le parole comuni
    gestisciScorrimento(ListaConcettiPulita,[],[],[]),          %gestisce lo scorrimento e fa il lavoro
    gestisciFrasiTraParentesi,                                  %fa il lavoro per le frasi tra parentesi
    main(Rest).                                                 %costruisce una nuova finestra

%gestisciScorrimento(+L,+Sensi,Roles,Relations).
%crea finestre sucessive facendo scorrere una finestra sulla lista L e su queste compie un certo lavoro (doWork)
gestisciScorrimento([],_,_,_):-!.
gestisciScorrimento(L,Sensi,Roles,Relations):-
    length(L,Len),                                         %quant' lunga
    windowsLength(WL),                                     %rispetto a WL?
    Len > WL,!,                                            %piu lunga
    primiWL(L,Window),                                     %prende i primi WL,
    doWork(Window,NuoviSensi,NRoles,NRelations),           %estrae i ruoli e le relazioni
    unisciRoles(Roles,NRoles,RolesTot),                    %concatena i ruoli
    unisciRelations(Relations,NRelations,RelationsTot),    %concatena le relazioni
    unisciSensi(Sensi,NuoviSensi,SensiTot),                %crea la lista totale dei sensi del segmento
    tail(L,NuovaL),                                        %taglia il primo elemento di L
    gestisciScorrimento(NuovaL,SensiTot,RolesTot,RelationsTot).    %ricorre

gestisciScorrimento(L,Sensi,Roles,Relations):-
    length(L,Len),                                         %quant' lunga
    windowsLength(WL),                                     %rispetto a WL?
    Len =< WL,                                             %piu corta o uguale
    Window = L,                                            %la prende tutta e
    doWork(Window,NuoviSensi,NRoles,NRelations),           %estrae i ruoli
    unisciRoles(Roles,NRoles,RolesTot),                    %concatena i ruoli
    unisciRelations(Relations,NRelations,RelationsTot),    %concatena le relazioni
    unisciSensi(Sensi,NuoviSensi,SensiTot),                %crea la lista totale dei sensi del segmento
    stampaSensi(SensiTot),                                 %stampa in un formato carino
    write(RolesTot),nl,
    write(RelationsTot).                %stampa Roles e rel

%unisciSensi(+Sensi,+NuoviSensi,?SensiTot).
%Sensi e NuoviSensi sono le liste dei sensi calcolate in doWork, SensiTot e' il merge delle due = una lista di liste di elementi sense(Syn,Word,POS,Value)
unisciSensi([],NuoviSensi,SensiTot):-!,
    listaElementi(NuoviSensi,SensiTot).

unisciSensi(Sensi,NuoviSensi,SensiTot):-
    windowsLength(WL),
    WL1 is WL-1,
    dividi(Sensi,WL1,PrimiSensi,UltimiSensi),
    mergeSensi(UltimiSensi,NuoviSensi,[],SensiMerge),
    append(PrimiSensi,SensiMerge,SensiTot).

%trasforma ogni elemento in una lista contenente il solo elemento
listaElementi([],[]):-!.
listaElementi([E|R],[[E]|R2]):-
    listaElementi(R,R2).

%fine prima lista    
mergeSensi([],[sense(NSyn,NWord,NPOS,NValue)],Acc,SensiMerge):-!,
    append(Acc,[[sense(NSyn,NWord,NPOS,NValue)]],SensiMerge).

%c'e' in L ma con Value minore allora lo sostituisco
mergeSensi([L|R],[sense(NSyn,NWord,NPOS,NValue)|NR],Acc,SensiMerge):-
    member(sense(NSyn,_,_,Value),L),
    Value < NValue,!,
    sostituisciIn([sense(NSyn,NWord,NPOS,NValue)],L,NL),
    append(Acc,[NL],NewAcc),
    mergeSensi(R,NR,NewAcc,SensiMerge).
 
%non c'e' in L allora lo inserisco
mergeSensi([L|R],[sense(NSyn,NWord,NPOS,NValue)|NR],Acc,SensiMerge):-
    not(member(sense(NSyn,_,_,_),L)),!,
    append(L,[sense(NSyn,NWord,NPOS,NValue)],NL),
    append(Acc,[NL],NewAcc),
    mergeSensi(R,NR,NewAcc,SensiMerge). 

%c'e' in L con Value maggiore allora ricorro
mergeSensi([L|R],[sense(_,_,_,_)|NR],Acc,SensiMerge):-
    append(Acc,[L],NewAcc),
    mergeSensi(R,NR,NewAcc,SensiMerge).

%Ultimi sono gli ultimi N elementi, Primi quelli che vengono prima
dividi(L,N,Primi,Ultimi):-
    length(Ultimi,N),
    append(Primi,Ultimi,L).

%SostituisciIn(+[S],+L,?NL) sostituisce S in L e la chiama NL 
sostituisciIn([sense(NSyn,NWord,NPOS,NValue)],L,NL):-
        append(XS,Y,L),
        append(X,[sense(NSyn,_,_,_)],XS),!,
        append(X,[sense(NSyn,NWord,NPOS,NValue)],NXS),
        append(NXS,Y,NL).

%unisciRelations(+Relations,+NRelations,?RelationsTot).
%fa il merge delle liste
unisciRelations(Relations,NRelations,RelationsTot):-
     unisciRel(Relations,NRelations,Relations,RelationsTot).

%unisciRel(+Relations,+NRelations,+Acc,?RelationsTot).
%RelationsTot  la lista degli elementi che stanno in Relations e NRelations
unisciRel(_,[],Acc,Acc):-!.       %finita la lista
unisciRel(Relations,[E|R],Acc,RelTot):-   %se  membro l'Acc non cambia
     member(E,Relations),!,
     unisciRel(Relations,R,Acc,RelTot).
unisciRel(Relations,[E|R],Acc,RelTot):-       %se non  membro lo inserisco nell'Acc
     append(Acc,[E],NewAcc),
     unisciRel(Relations,R,NewAcc,RelTot).

%unisciRoles(+Roles,+NRoles,?RolesTot).
%RolesTot  la lista degli elementi che stanno in Relations e NRelations
unisciRoles([],NuoviRoles,RolesTot):-
     !,listaElementi(NuoviRoles,RolesTot).

unisciRoles(Roles,NuoviRoles,RolesTot):-
    windowsLength(WL),
    WL1 is WL-1,
    dividi(Roles,WL1,PrimiRoles,UltimiRoles),
    mergeRoles(UltimiRoles,NuoviRoles,[],RolesMerge),
    append(PrimiRoles,RolesMerge,RolesTot).

%fine prima lista
mergeRoles([],[E],Acc,RolesMerge):-!,
    append(Acc,[[E]],RolesMerge).

%c'e' in L proseguo
mergeRoles([L|R],[(Word,Role,POS,Syn)|NR],Acc,RolesMerge):-
    member((Word,Role,POS,Syn),L),!,
    append(Acc,[L],NewAcc),
    mergeRoles(R,NR,NewAcc,RolesMerge).

%non c'e' in L allora lo inserisco
mergeRoles([L|R],[(Word,Role,POS,Syn)|NR],Acc,RolesMerge):-
    append(L,[(Word,Role,POS,Syn)],NL),
    append(Acc,[NL],NewAcc),
    mergeRoles(R,NR,NewAcc,RolesMerge).







%stampaSensi(+SensiTot).
%stampa il tutto su file
%[  [sense(Syn,Word,POS,Value),sense(Syn,Word,POS,Value)]  ,[sense(Syn,Word,POS,Value)],  [sense(Syn,Word,POS,Value)],  []...]
stampaSensi([]):-!,write('.'),nl.
stampaSensi([[sense(Syn,Word,POS,_)]|R]):-
    !,
    write(Word),
    write('  '),
    write(Syn),
    write('  '),
    write(POS),nl,
    stampaSensi(R).

stampaSensi([L|R]):-
    totaleScore(L,TS),
    stampaPerc(L,TS),
    stampaSensi(R).

%totaleScore(+L,?TS).
%calcola il TotalScore, ovvero la somma delle Value di una lista di significati per una parola
totaleScore([],0):-!.
totaleScore([sense(_,_,_,Value)|R],TS):-
    totaleScore(R,PS),
    TS is PS+Value.

%stampaPerc(+L,+TS).
%calcola la percentuale di ogni significato in L e la stampa alla fine della stampa normale
stampaPerc([],_):-!.
stampaPerc([sense(Syn,Word,POS,Value)|R],TS):-
    write(Word),
    write('  '),
    write(Syn),
    write('  '),
    write(POS),
    write('  '),
    Perc is Value*100/TS,
    write(Perc),
    write('%'),nl,
    stampaPerc(R,TS).
    

%gestisce le frasi tra parentesi ricominciando la procedura
gestisciFrasiTraParentesi:-
    betweenBrackets(L),!,
    retract(betweenBrackets(L)),
    tokenizeToPoint(L, ListaParole,_),
    lookAheadList(ListaParole,ListaConcetti),
    rimuoviNonSignificativi(ListaConcetti,ListaConcettiPulita),
    gestisciScorrimento(ListaConcettiPulita,[],[],[]),
    gestisciFrasiTraParentesi.

gestisciFrasiTraParentesi.
    
%tail(L,T).
%T  L eccetto il suo primo elemento
tail([],[]):-!.
tail([_|T],T).

%primiWL(L,K).
%K  la lista dei primi WL elementi di L, dove WL  la lunghezza della finestra
primiWL([],[]):-!.
primiWL(L,K):-
    windowsLength(WL),
    length(L,Len),
    Len > WL,!,
    length(K,WL),
    append(K,_,L).
primiWL(L,L).

%rimuoviNonSignificativi(ListaConcetti,ListaConcettiPulita).
%ListaConcettiPulita  la lista degli elementi di ListaConcetti che sono significativi
rimuoviNonSignificativi([],[]):-!.
rimuoviNonSignificativi([E|L],[Evalid|Concetti]):-
    baseWord(E,Evalid),!,
    rimuoviNonSignificativi(L,Concetti).

rimuoviNonSignificativi([_|L],Concetti):-
    rimuoviNonSignificativi(L,Concetti).

%baseWord(+Word, ?BaseWord)
%BaseWord  unificato con Word se sta in WN oppure con la coniugazione del verbo al futuro o il singolare della parola se in WN
%se Word  una parola comune fallisce
baseWord(Word,_):-
      atom_codes(Word,Atom),                                                  %Atom  la lista degli ASCII di Word
      toLower(Atom,AtomMin),                                                  %AtomMin  la lista degli ASCII minuscoli
      atom_codes(WordMin,AtomMin),                                            %WordMin  la parola minuscola
      commonWords(L),member(WordMin,L),!,fail.                                %se  una parola comune fallisce

baseWord(Word,WordMin):-
     atom_codes(Word,Atom),                                                   %Atom  la lista degli ASCII di Word
     toLower(Atom,AtomMin),                                                   %AtomMin  la lista degli ASCII minuscoli
     atom_codes(WordMin,AtomMin),                                             %WordMin  la parola minuscola
     wordRecognition(WordMin),!.                                              %guarda se trova la forma non coniugata in WN

baseWord(Word,Word):-
     wordRecognition(Word).                                                   %guarda se trova la forma non coniugata in WN

%toLower(+List, ?MinList)
%unifica MinList con la lista degli elementi in List resi minuscoli
toLower([E|T],[M|R]):-
     E >= "A",
     E =< "Z",!,                                                              %E  maiuscolo
     M is E +"a"-"A",                                                         %M  E minuscolo
     toLower(T,R).                                                            %ricorre
toLower([E|T],[E|R]):-
     !,toLower(T,R).                                                          %E non  maiuscolo, ricorre
toLower([],[]).

%doWork(+L,?Sensi,?Roles,?Relations).
%lavora
doWork(W,Sensi,Roles,Relations):-
    disambigua(W,W,Sensi),print('user',Sensi),
    findRoles(Sensi,Roles),
    findRelationsByPOS(Sensi,Relations).

%findRoles(+Sensi,?Roles).
%Roles  la lista delle tuple (Word,Role,POS,Syn), dove Role  il concetto piu generale di Word
%questa relazione non vale per aggettivi e avverbi, soltanto per nomi e verbi
findRoles([],[]):-!.
findRoles([sense(Syn,Word,noun,_)|Rest],[(Word,Role,noun,Syn)|Roles]):-
    !,findRoleByGloss(Syn,Role),
    findRoles(Rest,Roles).
findRoles([sense(Syn,Word,verb,_)|Rest],[(Word,Role,verb,Syn)|Roles]):-
    !,findRoleByGloss(Syn,Role),
    findRoles(Rest,Roles).
findRoles([sense(Syn,Word,POS,_)|Rest],[(Word,noRole,POS,Syn)|Roles]):-
    findRoles(Rest,Roles).
    
%mette la parola tra apici singoli
apicizza(Stringa,Result):-
   atom_codes(Stringa,A),
   append([39],A,A1),
   append(A1,[39],Afin),
   atom_codes(Result,Afin).
