% Author: MB
% Date: 16/11/2009

:- ensure_loaded('artAndPrep.pl').
:- ensure_loaded('freq8000words.pl').
:- ensure_loaded('wn_tools.pl').
     
%piu' il moltiplicatore  grande, piu' alta sar la scrematura delle parole
moltiplicatore(10).

%numero di parole nei corpus
%gutenbergWords(1712082956).
bnc(100106029).

%testing per il preprocess
stampa:-
        preprocess("In science fiction, the Three Laws of Robotics are a set of three rules written by Isaac Asimov, which almost all positronic robots appearing in his fiction must obey. Introduced in his 1942 short story Runaround, although foreshadowed in a few earlier stories, the Laws state the following: 1. A robot may not injure a human being or, through inaction, allow a human being to come to harm. 2. A robot must obey any orders given to it by human beings, except where such orders would conflict with the First Law. 3. A robot must protect its own existence as long as such protection does not conflict with the First or Second Law.",L),
        print('user',L).
        
%preProcess(+Testo, ?ListaCommonWords).
%unifica ListaCommonWords con la lista delle parole comuni del Testo che siano articoli o preposizioni
preprocess(Testo, ListaCommonWords):-
     tokenize(Testo,ListaParole),
     length(ListaParole,NumParole),                                           %NumParole  il numero di parole che stanno nel Testo
     selezionaArticoliEPreposizioni(ListaParole,ArtEPrep),                    %seleziona gli articoli e le prposizioni, scarta il resto
     conta(ArtEPrep,[],ListaOccorrenze),                                      %ListaOccorrenze nella forma [(Term,numRip),(),()..]
     calcolaFrequenza(ListaOccorrenze,NumParole,[],ListaFrequenze),           %calcola la frequenza delle parole nel Testo
     findCommonWords(ListaFrequenze,[],ListaCommonWords).                     %ListaCommonWords  la lista delle parole comuni

%selezionaArticoliEPreposizioni(+ListaParole,?ArtEPrep).
%ArtEPrep  la lista degli articoli e delle preposizioni presenti in ListaParole,senza elimininare i doppioni
selezionaArticoliEPreposizioni([],[]):-!.

selezionaArticoliEPreposizioni([E|L],[E|K]):-
     article(E),!,
     selezionaArticoliEPreposizioni(L,K).

selezionaArticoliEPreposizioni([E|L],[E|K]):-
     preposition(E),!,
     selezionaArticoliEPreposizioni(L,K).
     
selezionaArticoliEPreposizioni([_|L],K):-
     selezionaArticoliEPreposizioni(L,K).

%conta(+ListaParole,?Acc,?ListaOccorrenze).
%unifica ListaOccorrenze con la lista delle coppie (Parola,Num), dove Parola fa parte di ListaParole e
%Num  il numero di volte che si ripete nelle lista
conta([Parola|Resto],Acc,ListaFinale):-
     member((Parola,Num),Acc),!,
     Num1 is Num + 1,
     delete(Acc,(Parola,Num),LTemp),
     conta(Resto,[(Parola,Num1)|LTemp],ListaFinale).
     
conta([Parola|Resto],Acc,ListaFinale):-
     conta(Resto,[(Parola,1)|Acc],ListaFinale).

conta([],Acc,Acc).
     
%calcolaFrequenza(+ListaOccorrenze,+NumParole,?Acc,?ListaFrequenze).
%ListaFrequenze  la lista delle coppie (Parola,Freq), dove Parola fa parte di ListaOccorrenze e Freq  la percentuale di ripetizione
calcolaFrequenza([(Parola,N)|R],NumParole,Acc,ListaFrequenze):-
     F is N / NumParole,
     calcolaFrequenza(R,NumParole,[(Parola,F)|Acc],ListaFrequenze).
     
calcolaFrequenza([],_,Acc,Acc).

%findCommonWords(+ListaFrequenze,?Acc,?ListaCommonWords).
%ListaCommonWords  la lista delle parole la cui frequenza non supera una certa soglia
findCommonWords([(W,F)|R],Acc,Commons):-
     isCommon(W,F),!,
     findCommonWords(R,[W|Acc],Commons).

findCommonWords([(_,_)|R],Acc,Commons):-
     findCommonWords(R,Acc,Commons).
     
findCommonWords([],Acc,Acc).

%se non  in freq non  una parla comune, giusto tenerla.
isCommon(W,F):-
     freq(W,Freq),
     moltiplicatore(M),
     FreqSqrt is sqrt(Freq),
     FSqrt is sqrt(F),
     FSqrt < FreqSqrt * M.