% Author: MB
% Date: 28/11/2009

:- ensure_loaded( 'pronto_morph_engine.pl').
:- ensure_loaded( 'pronto_morph_spelling_rules.pl').
:- ensure_loaded( 'pronto_morph_irreg_adj.pl' ).
:- ensure_loaded( 'pronto_morph_irreg_adv.pl' ).
:- ensure_loaded( 'pronto_morph_irreg_noun.pl' ).
:- ensure_loaded( 'pronto_morph_irreg_verb.pl' ).
:- ensure_loaded( 'wn_s.pl' ).

%my_s(+A,+B,+C,+D,+E,+F)
%Vale sia per le clausole s/6 definite in WN che per le clausole ass_s/6 dfefinite da me.
my_s(A,B,C,D,E,F) :-
        ass_s(A,B,C,D,E,F).
my_s(A,B,C,D,E,F) :-
        s(A,B,C,D,E,F).
        
%lista dei possibili suffissi dei verbi.
verbsSuffix([-s, -ed, -en, -ing, -past, -pl, -sg3]).

%lista dei possibili suffissi dei verbi.
nounsSuffix([-pl, -s]).

%lista dei possibili suffissi dei verbi.
adjectivesSuffix([-er, -est]).

%lista dei possibili suffissi dei verbi.
adverbsSuffix([-er, -est]).

%wordRecognition(+Word1, ?Word2)
%asserisce W per tutti i morfemi di W in wordnet. Fallisce se W e suoi morfemi non stanno in wn_s
wordRecognition(W):-
     verbRecognition(W,Len1),
     nounRecognition(W,Len2),
     adjectiveRecognition(W,Len3),
     adjectiveRecognition2(W,Len4),
     adverbRecognition(W,Len5),
     L is Len1+Len2+Len3+Len4+Len5,
     L>0,!.
     
wordRecognition(W):-
     my_s(_,_,W,_,_,_).

verbRecognition(W,Len):-
     verbsSuffix(SuffixList),
     findall(ass_s(S,N1,W,v,N2,N3),(morph_atoms(W,[[Morph,Suffix]|_]),member(Suffix,SuffixList),s(S,N1,Morph,v,N2,N3)),L),
     length(L,Len),
     findall(E,(member(E,L),assert(E)),_).
     
nounRecognition(W,Len):-
     nounsSuffix(SuffixList),
     findall(ass_s(S,N1,W,n,N2,N3),(morph_atoms(W,[[Morph,Suffix]|_]),member(Suffix,SuffixList),s(S,N1,Morph,n,N2,N3)),L),
     length(L,Len),
     findall(E,(member(E,L),assert(E)),_).
     
adjectiveRecognition(W,Len):-
     adjectivesSuffix(SuffixList),
     findall(ass_s(S,N1,W,a,N2,N3),(morph_atoms(W,[[Morph,Suffix]|_]),member(Suffix,SuffixList),s(S,N1,Morph,a,N2,N3)),L),
     length(L,Len),
     findall(E,(member(E,L),assert(E)),_).

adjectiveRecognition2(W,Len):-
     adjectivesSuffix(SuffixList),
     findall(ass_s(S,N1,W,s,N2,N3),(morph_atoms(W,[[Morph,Suffix]|_]),member(Suffix,SuffixList),s(S,N1,Morph,s,N2,N3)),L),
     length(L,Len),
     findall(E,(member(E,L),assert(E)),_).

adverbRecognition(W,Len):-
     adverbsSuffix(SuffixList),
     findall(ass_s(S,N1,W,r,N2,N3),(morph_atoms(W,[[Morph,Suffix]|_]),member(Suffix,SuffixList),s(S,N1,Morph,r,N2,N3)),L),
     length(L,Len),
     findall(E,(member(E,L),assert(E)),_).